from azure.datalake.store.lib import DataLakeCredential
import logging
import time
import adal

""" The follow are a list of hacks to coerce the adal python sdk
    to play nice with an authentication token from a REST call.

    Also provides an overriden class DataCredentialEndUser that will correctly
    refresh a token using a secret key if provided """

def ConvertRestToken(token: dict, tenant_id: str, client_id: str, client_secret: str) ->  dict:
    token.update({
        'time': int(token['not_before']),

        # massage values from javascript (ADL Rest API) to be compatible with the microsoft ADAL
        'tokenType': token.pop('token_type'),
        'expiresIn': int(token.pop('expires_in')),
        'access': token.pop('access_token'),
        'tenant': tenant_id,
        'client': client_id
    });

    if client_secret:
        token['secret'] = client_secret

    if 'refresh_token' in token:
        token.update({'refresh': token['refresh_token']});
    return token

#class DataLakeCredentialEndUser(DataLakeCredential):
    #def __init__(self, token: dict):
        #super().__init__(token)

    #def refresh_token(self, authority=None):
        #""" Refresh an expired authorization token

        #Parameters
        #----------
        #authority: string
            #The full URI of the authentication authority to authenticate against (such as https://login.microsoftonline.com/)
        #"""

        #if self.token.get('refresh', False) is False and (not self.token.get('secret') or not self.token.get('client')):
            #raise ValueError("Token cannot be auto-refreshed.")

        #if not authority:
            #authority = 'https://login.microsoftonline.com/'

        #context = adal.AuthenticationContext(authority +
                                             #self.token['tenant'])
        #out = context.acquire_token_with_refresh_token(self.token['refresh'],
                                                        #client_id=self.token.get('client'),
                                                        #client_secret=self.token.get('secret'),
                                                        #resource=self.token.get('resource'))
        #out.update({'refresh': out['refreshToken']})
        ## common items to update
        #out.update({'access': out['accessToken'],
                    #'time': time.time(), 'tenant': self.token['tenant'],
                    #'resource': self.token['resource'], 'client': self.token['client']})

        #self.token = out